 <!--
======================================
S14 - Bootstrap - Layout and Best Practices
======================================
-->

<!-- https://getbootstrap.com/docs/4.3/utilities/spacing/ -->

<!-- 
==========
Discussion
========== 
-->


<!-- 
1. Create an "index.html" file.
    Batch Folder > S14 > index.html
-->


        <!DOCTYPE html>
        <html>
        <head>
            <title>Bootstrap - Layout and Best Practices</title>
        </head>
        <body>

        </body>
        </html>



<!--
2. Apply Bootstrap to the project by adding all the dependencies.
    Application > index.html
-->



        <!DOCTYPE html>
        <html>
        <head>

            <!-- Mobile Responsive Meta Tag -->
            <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

            <!-- Bootstrap Link -->
            <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" crossorigin="anonymous">

            <title>Bootstrap Components</title>

        </head>
        <body>

            <!-- Bootstrap Script -->
            <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
            <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.bundle.min.js" integrity="sha384-Piv4xVNRyMGpqkS2by6br4gNJ7DXjqk09RmUpJ8jgGtD7zP9yug3goQfGII0yAns" crossorigin="anonymous"></script>

        </body>
        </html>


        <!--
        Important Note:
            - Upon completion of this material, Bootstrap 5.0 was the latest version.
            - Some of the materials are still using Bootstrap 4.6.
            - To avoid any problems and errors encountered during the discussion, it is advised to implement the same version of Bootstrap.
            - An alternative way of implementing Bootstrap is to download it and store a copy in the local project.
            - The Responsive Meta Tag is responsible for making Bootstrap work properly. It disables the browser zoom view and allows elements to be rendered to scale to the size of the screen.
            - Refer to "references" section of this file to find the documentations for Bootstrap CSS Framework, Bootstrap local vs. CDN, Responsive Meta Tag and Bootstrap Containers.
            - Refer to "references" section of this file to find the documentation for Introduction to Bootstrap 5 on where to get the code snippets to apply Bootstrap into our project.
        -->


<!--
3. Add a content and style.
    Application > index.html
-->

        <div>
            <div class="bg-light border">Item 1</div>
            <div class="bg-light border">Item 2</div>
            <div class="bg-light border">Item 3</div>
        </div>


<!--
4. Add a padding using Bootstrap Spacing.
    Application > index.html
-->


        <div>
            <div class="p-2 bg-light border">Item 1</div>
            <div class="p-2 bg-light border">Item 2</div>
            <div class="p-2 bg-light border">Item 3</div>
        </div>

        <!--
        Important Note:
            - You can use other sizes to demonstrate it to students.
        -->

<!--
5. Add a margin and padding using Bootstrap Spacing.
    Application > index.html
-->


        <div class="m-5">
            <div class="p-2 bg-light border ms-5">Item 1</div>
            <div class="p-2 bg-light border me-5">Item 2</div>
            <div class="p-2 bg-light border mx-5">Item 3</div>
        </div>

        <!--
        Important Note:
            - You can use other sizes to demonstrate it to students.
            - The sides of p is also the same with m. Let the students explore the use of spacing sides and sizes.
        -->


<!--
6. Add a display: grid of gap utilities on the parent container.
    Application > index.html
-->


        <div class="m-5 d-grid gap-3">
            <div class="p-2 bg-light border ms-5">Item 1</div>
            <div class="p-2 bg-light border me-5">Item 2</div>
            <div class="p-2 bg-light border mx-5">Item 3</div>
        </div>

        <!--
        Important Note:
            - You can use other sizes to demonstrate it to students.
        -->

<!--
7. Add horizontal centering on the parent container.
    Application > index.html
-->

        <div class="m-5 d-grid gap-3 mx-auto" style="width: 500px;">
            <div class="p-2 bg-light border ms-5">Item 1</div>
            <div class="p-2 bg-light border me-5">Item 2</div>
            <div class="p-2 bg-light border mx-5">Item 3</div>
        </div>


<!--
7. Comment out the content of the body, then add this template to layout our page using the Bootstrap.
    Application > index.html
-->

    <!-- 
    7.a Add style inside the head tag to add image
     -->
            <head>
                    <!-- Bootstrap Link -->
                    <!-- ... -->

                    <title>Bootstrap - Layout and Best Practices</title>
           
                    <style>
                        .sample-image {
                          background-image: url("https://place-puppy.com/450x450");
                          background-size: cover;
                          height: 400px;
                        }
                    
                  </style>
            </head>

    <!-- 
    7.b Add the template in the body.
    -->

            <body>
                <main>
                    <header>
                        <div>
                            <h1>Welcome to My Website</h1>
                        </div>
                    </header>
             
                    <nav>
                        <div>Home</div>
                        <div>About</div>
                        <div>Contact</div>    
                    </nav>
                               
                    <section>
                        <figure>
                            <div>
                                <img src="https://place-puppy.com/550x350">
                            </div>
                        </figure>
                        <figcaption>
                            <h2>About Us</h2>
                            <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc interdum risus sed arcu commodo, at cursus magna porttitor. Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
                            tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
                            quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
                            consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
                            cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
                            proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
                        </figcaption>
                    </section>
                    
                    <section>
                        <div>
                            <div>
                                <h3>Feature 1</h3>
                            </div>
                        </div>

                        <div>
                            <div>
                                <h3>Feature 2</h3>
                            </div>
                        </div>

                        <div>
                            <div>
                                <h3>Feature 3</h3>
                            </div>
                        </div>
                    </section>
                    
                    <footer>
                        <div>Footer</div>
                        <div>|</div>
                        <div>Terms of Use</div>
                        <div>|</div>
                        <div>Copyright 2023</div>
                    </footer>
                </main>


                <!-- Bootstrap Script -->
                <!-- ... -->
            </body>


<!--
8. Add a class container in the main tag to add a margin.
    Application > index.html
-->

        <body>
            <main class="container">
                <!-- ... -->


<!--
9. Set the row and column of the header then add margin and center the text.
    Application > index.html
-->

        <main class="container">
            <header class="row mt-5">
                <div class="col-lg-12">
                    <h1 class="text-center">Welcome to My Website</h1>
                </div>
            </header>

        <!-- 
        Important Note:
            This Grid System is made of three components namely:

                - Container: A ‘<div>’ or any container element effectively holds rows and columns and plays a vital role in offering the correct width to a particular layout.
                - Rows: It is a class .row component that discharges the padding menu and acts as a wrapper all over the columns.
                - Columns: In Bootstrap, different column class prefixes are used for the diverse sizes of devices.

            Adding the Grid System makes it is easy to make layouts, leading to achieving the required milestone. Creating columns of similar heights and widths is a major knack of this grid system, which makes it unique and helps you achieve much more realistic columns. This will provide a consistent layout. It will be easy to use and customize whenever we want to modify it.


            Working with the Bootstrap grid system brings in a certain set of important rules comprising:

                - Columns should be the instant child of the Rows.
                - The Rows should only consist of Columns.
                - The correct position of Rows is inside the Container.
         -->


<!--
10. Add the display: flex and spacing needed in nav element.
    Application > index.html
-->
            <!-- add the class one at a time to demonstrate each behavior -->
            <nav class="d-flex justify-content-center d-grid gap-5 bg-warning p-2">
                <div>Home</div>
                <div>About</div>
                <div>Contact</div>    
            </nav>

            <!-- Check the responsiveness by opening the inspect in your browser. -->


<!--
11. For the 1st section, create a two columns to separate the image and its text.
    Application > index.html
-->

            <section class="row mt-5">
                <figure class="col-lg-6">
                    <div class="sample-image"></div>
                </figure>
                <figcaption class="col-lg-6">
                    <h2>About Us</h2>
                    <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc interdum risus sed arcu commodo, at cursus magna porttitor. Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
                    tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
                    quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
                    consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
                    cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
                    proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
                </figcaption>
            </section>

            <!-- 
            Important Note:
                Bootstrap's grid system allows up to 12 columns across the page. Since we just need a 2 column, we add a size of 6 per column

                Check the responsiveness by opening the inspect in your browser.
             -->


<!--
12. Add grid system in Feature section.
    Application > index.html
-->

            <section class="row mt-5 text-center">
                <div class="col-lg-4 col-md-6">
                    <div class="p-5 border">
                        <h3>Feature 1</h3>
                    </div>
                </div>

                <div class="col-lg-4 col-md-6">
                    <div class="p-5 border">
                        <h3>Feature 2</h3>
                    </div>
                </div>

                <div class="col-lg-4 col-md-12">
                    <div class="p-5 border">
                        <h3>Feature 3</h3>
                    </div>
                </div>
            </section>

            <!-- 
            Important Note:
                By adding sizes lg and md, we can control the layout per screen sizes. 
                    - we added 4 for each lg sizes to set the width equally
                    - To achieve equal sizing for the two columns, we incorporated md-6, while md-12 was utilized to set it to full width.
                    - the default will be applied to sm so no need to add its size.
             -->


<!--
13. Add grid system in the Footer section.
    Application > index.html
-->

            <footer  class="d-flex justify-content-center d-grid gap-3 m-5">
                <div>Footer</div>
                <div>|</div>
                <div>Terms of Use</div>
                <div>|</div>
                <div>Copyright 2023</div>
            </footer>


<!-- 
========
Activity
======== 
-->


<!-- 
=================================
s14 - Activity Instructions
=================================
Instructor’s Note: Do not update style attributes to the elements. Apply only the appropriate bootstrap class.

Instructions that can be provided to the students for reference:
Activity References:
Bootstrap Text Utility Classes
    https://getbootstrap.com/docs/4.6/utilities/text/
What is Mobile First Design
    https://medium.com/@Vincentxia77/what-is-mobile-first-design-why-its-important-how-to-make-it-7d3cf2e29d00
Bootstrap Border Utility Classes
    https://getbootstrap.com/docs/4.6/utilities/borders/
Bootstrap Sizing Utility Classes
    https://getbootstrap.com/docs/4.6/utilities/sizing/
HTML Blocks
    https://www.tutorialspoint.com/html/html_blocks.htm
    https://www.w3schools.com/html/html_blocks.asp
HTML Elements
    https://developer.mozilla.org/en-US/docs/Glossary/Element
Bootstrap Position Utility Classes
    https://getbootstrap.com/docs/4.6/utilities/position/
Bootstrap Spacing Utility Classes
    https://getbootstrap.com/docs/4.6/utilities/spacing/
Bootstrap Display Utility Classes
    https://getbootstrap.com/docs/4.6/utilities/display/
Bootstrap Image Utility Classes
    https://getbootstrap.com/docs/4.6/content/images/

Activity:
Member 1:
1. In the S14 folder, create an activity folder.
- Copy the template from boodle notes and paste it in the in the index.html file.
- Update your local sessions git repository and push to git with the commit message of Add template code s14
2. Apply Bootstrap to the project by adding all the dependencies.
3. Add bootstrap classes to the element "nav” to:
    - Add a bootstrap class to inline all the text
    - Add a bootstrap class to add a dark bg color to the nav element
    - Add padding to the navbar element using bootstrap classes
    - Add a bootstrap class to element “nav”: "My Website" on the left side and About, Services on the right side.

Member 2:
4. Add a bootstrap class to Banner Section:
    - Add a spacing on the left/right side and a danger bg.

Member 3:
5. Add a bootstrap to the About Section:
    - Add space on top and bottom sides.
    - Divide the columns into two:
        - About Us on the left side. 
        - The image on the right side.

Member 4:
6. Add a bootstrap to the Services Section:
    - Divide the columns into three for the larger size
    - For md size, equal sizing for the two columns, and set the other column to full width.
    - Center the text
    - Add border and spacing

Member 5:
7. Add a bootstrap to the Footer Section:
    - apply dark bg and white text
    - inline all the elements
    - add spacing to the elements


All Members:
8. Check out to your own git branch with git checkout -b <branchName>
9. Update your local sessions git repository and push to git with the commit message of Add activity code s14.
10. Add the sessions repo link in Boodle for s14.

-->

<!-- 
===============
Solution
===============
 -->


 <!--
 1. Add Bootstrap dependencies 
-->

<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">

        <!-- Bootstrap -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/css/bootstrap.min.css">

        <title>S14 - Activity</title>

    </head>
    <body>
        

        <!-- Bootstrap -->
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/js/bootstrap.bundle.min.js"></script>
    </body>
</html>

<!--
2. Navbar Section
-->

        <!-- Navbar -->
        <nav class="d-flex justify-content-center d-grid gap-5 px-5 py-3 bg-dark text-white">
            <div>My Website</div>
            <div class="ms-auto d-flex justify-content-center d-grid gap-5 bg-dark">
                <div>About</div>
                <div>Services</div>    
            </div>      
        </nav>


<!--
3. Banner Section
-->

        <!-- Banner Section -->
        <section class="bg-danger text-white py-5">
            <div class="mx-5">
                <h1>Welcome to My Website</h1>
                <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>
            </div>
        </section>

<!--
4. About Section
-->


        <!-- About Section -->
        <section class="py-5">
            <div class="container">
                <div class="row">
                    <div class="col-lg-6">
                        <h2>About Us</h2>
                        <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla tincidunt nisi et sem eleifend aliquet. Fusce interdum rutrum ipsum, non feugiat risus consectetur eu. Nulla sodales orci et mi ultrices, at mattis leo gravida. Curabitur non dapibus orci.</p>
                    </div>
                    <div class="col-lg-6">
                        <img src="https://place-puppy.com/550x350" class="img-fluid">
                    </div>
                </div>
            </div>
        </section>


<!--
5. Services Section
-->


        <!-- Services Section -->
        <section class="container">
            <div class="row my-5 text-center">
                <div class="col-lg-4 col-md-6">
                    <div class="p-5 border">
                        <h3>Web Development</h3>
                        <p>We provide professional web development services.</p>

                    </div>
                </div>

                <div class="col-lg-4 col-md-6">
                    <div class="p-5 border">
                        <h3>Graphic Design</h3>
                        <p>Our talented designers create stunning graphics for your brand.</p>
                    </div>
                </div>

                <div class="col-lg-4 col-md-12">
                    <div class="p-5 border">
                        <h3>Digital Marketing</h3>
                        <p>We help businesses grow their online presence.</p>
                    </div>
                </div>
            </div>
        </section>


<!--
6. Footer Section
-->

        <!-- Footer -->
        <footer  class="d-flex justify-content-center d-grid gap-3 py-3 bg-dark text-white">
            <div>&copy;  2023 My Website.</div>
            <div>|</div>
            <div>All rights reserved.</div>
        </footer>



